{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_AFCSubst
  ( C_AFCSubst
  , d_C_showAFCSubst
  , nd_C_showAFCSubst
  , d_C_emptyAFCSubst
  , nd_C_emptyAFCSubst
  , d_C_lookupAFCSubst
  , nd_C_lookupAFCSubst
  , d_C_substFunc
  , nd_C_substFunc
  , d_C_substRule
  , nd_C_substRule
  , d_C_substExpr
  , nd_C_substExpr
  , d_C_substSnd
  , nd_C_substSnd
  , d_C_substBranch
  , nd_C_substBranch
  , d_C_substPattern
  , nd_C_substPattern
  , d_C_subst
  , nd_C_subst )
  where

import Basics
import qualified Curry_AnnotatedFlatCurry
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_Prelude


type C_AFCSubst = Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr

d_C_showAFCSubst :: Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showAFCSubst cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unlines
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  d_OP_showAFCSubst_dot_showOne_dot_2) Curry_FiniteMap.d_C_fmToList cd cs) cd cs

nd_C_showAFCSubst :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showAFCSubst s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
  Curry_Prelude.d_C_unlines) (Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_map (wrapDX id d_OP_showAFCSubst_dot_showOne_dot_2)))
  (wrapNX id Curry_FiniteMap.nd_C_fmToList) s0 cd cs) s1 cd cs))

d_OP_showAFCSubst_dot_showOne_dot_2 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showAFCSubst_dot_showOne_dot_2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " -> ") (Curry_Prelude.d_C_show x3 cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showAFCSubst_dot_showOne_dot_2 l cd cs)
    (d_OP_showAFCSubst_dot_showOne_dot_2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showAFCSubst_dot_showOne_dot_2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_showAFCSubst_dot_showOne_dot_2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AFCSubst.showAFCSubst.showOne.2" [show x1] info)
  _ -> failCons cd (consFail "AFCSubst.showAFCSubst.showOne.2" (showCons x1))

d_C_emptyAFCSubst :: Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
d_C_emptyAFCSubst cd cs = Curry_FiniteMap.d_C_emptyFM (acceptCs id
  Curry_Prelude.d_OP_lt) cd cs

nd_C_emptyAFCSubst :: IDSupply -> Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
nd_C_emptyAFCSubst s cd cs = let s0 = s
  in s0 `seq` Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_lt)) s0 cd cs

d_C_lookupAFCSubst :: Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  Curry_FlatCurry.C_TypeExpr
d_C_lookupAFCSubst cd cs = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupAFCSubst :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Func
  Curry_Prelude.C_Int (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr))
nd_C_lookupAFCSubst s cd cs = wrapDX (wrapNX id) (acceptCs id
  Curry_FiniteMap.nd_C_lookupFM)

d_C_substFunc :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AFuncDecl
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr
d_C_substFunc x1 x2 cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_AFunc x3 x4 x5 x6 x7 -> Curry_AnnotatedFlatCurry.C_AFunc
    x3 x4 x5 (d_C_subst x1 x6 cd cs) (d_C_substRule x1 x7 cd cs)
  Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_substFunc x1 l cd cs) (d_C_substFunc x1 r cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl d i xs -> narrows cs d i (\z ->
    d_C_substFunc x1 z cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_substFunc x1 e cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl d info -> failCons d (traceFail
    "AFCSubst.substFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substFunc" (showCons x2))

nd_C_substFunc :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AFuncDecl
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr
nd_C_substFunc x1 x2 s cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_AFunc x3 x4 x5 x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_AnnotatedFlatCurry.C_AFunc x3 x4 x5 (nd_C_subst
    x1 x6 s0 cd cs) (nd_C_substRule x1 x7 s1 cd cs)))
  Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl d i l r -> narrow d i
    (nd_C_substFunc x1 l s cd cs) (nd_C_substFunc x1 r s cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl d i xs -> narrows cs d i (\z ->
    nd_C_substFunc x1 z s cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl d c e -> guardCons d c
    (nd_C_substFunc x1 e s cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl d info -> failCons d (traceFail
    "AFCSubst.substFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substFunc" (showCons x2))

d_C_substRule :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
d_C_substRule x1 x2 cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5 -> Curry_AnnotatedFlatCurry.C_ARule
    (d_C_subst x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_substSnd x1) x4 cd cs)
    (d_C_substExpr x1 x5 cd cs)
  Curry_AnnotatedFlatCurry.C_AExternal x6 x7 -> Curry_AnnotatedFlatCurry.C_AExternal
    (d_C_subst x1 x6 cd cs) x7
  Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r -> narrow d i (d_C_substRule
    x1 l cd cs) (d_C_substRule x1 r cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs -> narrows cs d i (\z ->
    d_C_substRule x1 z cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_ARule d c e -> guardCons d c (d_C_substRule
    x1 e cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_ARule d info -> failCons d (traceFail
    "AFCSubst.substRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substRule" (showCons x2))

nd_C_substRule :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
nd_C_substRule x1 x2 s cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_ARule
    (nd_C_subst x1 x3 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_substSnd x1)) x4 s1 cd cs) (nd_C_substExpr x1 x5 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_AExternal x6 x7 -> let s0 = s
    in s0 `seq` Curry_AnnotatedFlatCurry.C_AExternal (nd_C_subst x1 x6 s0 cd cs)
    x7
  Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r -> narrow d i (nd_C_substRule
    x1 l s cd cs) (nd_C_substRule x1 r s cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs -> narrows cs d i (\z ->
    nd_C_substRule x1 z s cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_ARule d c e -> guardCons d c (nd_C_substRule
    x1 e s cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_ARule d info -> failCons d (traceFail
    "AFCSubst.substRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substRule" (showCons x2))

d_C_substExpr :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_C_substExpr x1 x2 cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6 -> Curry_AnnotatedFlatCurry.C_AComb
    (d_C_subst x1 x3 cd cs) x4 (d_C_substSnd x1 x5 cd cs) (Curry_Prelude.d_C_map
    (d_C_substExpr x1) x6 cd cs)
  Curry_AnnotatedFlatCurry.C_AVar x7 x8 -> Curry_AnnotatedFlatCurry.C_AVar
    (d_C_subst x1 x7 cd cs) x8
  Curry_AnnotatedFlatCurry.C_ACase x9 x10 x11 x12 -> Curry_AnnotatedFlatCurry.C_ACase
    (d_C_subst x1 x9 cd cs) x10 (d_C_substExpr x1 x11 cd cs)
    (Curry_Prelude.d_C_map (d_C_substBranch x1) x12 cd cs)
  Curry_AnnotatedFlatCurry.C_ALit x13 x14 -> Curry_AnnotatedFlatCurry.C_ALit
    (d_C_subst x1 x13 cd cs) x14
  Curry_AnnotatedFlatCurry.C_AOr x15 x16 x17 -> Curry_AnnotatedFlatCurry.C_AOr
    (d_C_subst x1 x15 cd cs) (d_C_substExpr x1 x16 cd cs) (d_C_substExpr x1 x17
    cd cs)
  Curry_AnnotatedFlatCurry.C_ALet x18 x19 x20 -> Curry_AnnotatedFlatCurry.C_ALet
    (d_C_subst x1 x18 cd cs) (Curry_Prelude.d_C_map
    (d_OP_substExpr_dot_substBinding_dot_26 x1) x19 cd cs) (d_C_substExpr x1 x20
    cd cs)
  Curry_AnnotatedFlatCurry.C_AFree x21 x22 x23 -> Curry_AnnotatedFlatCurry.C_AFree
    (d_C_subst x1 x21 cd cs) (Curry_Prelude.d_C_map (d_C_substSnd x1) x22 cd cs)
    (d_C_substExpr x1 x23 cd cs)
  Curry_AnnotatedFlatCurry.C_ATyped x24 x25 x26 -> Curry_AnnotatedFlatCurry.C_ATyped
    (d_C_subst x1 x24 cd cs) (d_C_substExpr x1 x25 cd cs) (d_C_subst x1 x26 cd
    cs)
  Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r -> narrow d i (d_C_substExpr
    x1 l cd cs) (d_C_substExpr x1 r cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs -> narrows cs d i (\z ->
    d_C_substExpr x1 z cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e -> guardCons d c (d_C_substExpr
    x1 e cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_AExpr d info -> failCons d (traceFail
    "AFCSubst.substExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substExpr" (showCons x2))

nd_C_substExpr :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
nd_C_substExpr x1 x2 s cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_AComb
    (nd_C_subst x1 x3 s0 cd cs) x4 (nd_C_substSnd x1 x5 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_substExpr x1)) x6 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_AVar x7 x8 -> let s0 = s
    in s0 `seq` Curry_AnnotatedFlatCurry.C_AVar (nd_C_subst x1 x7 s0 cd cs) x8
  Curry_AnnotatedFlatCurry.C_ACase x9 x10 x11 x12 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_ACase
    (nd_C_subst x1 x9 s0 cd cs) x10 (nd_C_substExpr x1 x11 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_substBranch x1)) x12 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_ALit x13 x14 -> let s0 = s
    in s0 `seq` Curry_AnnotatedFlatCurry.C_ALit (nd_C_subst x1 x13 s0 cd cs) x14
  Curry_AnnotatedFlatCurry.C_AOr x15 x16 x17 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_AOr
    (nd_C_subst x1 x15 s0 cd cs) (nd_C_substExpr x1 x16 s1 cd cs)
    (nd_C_substExpr x1 x17 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_ALet x18 x19 x20 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_ALet
    (nd_C_subst x1 x18 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_substExpr_dot_substBinding_dot_26 x1)) x19 s1 cd cs) (nd_C_substExpr
    x1 x20 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_AFree x21 x22 x23 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_AFree
    (nd_C_subst x1 x21 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_substSnd x1)) x22 s1 cd cs) (nd_C_substExpr x1 x23 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_ATyped x24 x25 x26 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` Curry_AnnotatedFlatCurry.C_ATyped
    (nd_C_subst x1 x24 s0 cd cs) (nd_C_substExpr x1 x25 s1 cd cs) (nd_C_subst x1
    x26 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r -> narrow d i (nd_C_substExpr
    x1 l s cd cs) (nd_C_substExpr x1 r s cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs -> narrows cs d i (\z ->
    nd_C_substExpr x1 z s cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e -> guardCons d c (nd_C_substExpr
    x1 e s cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_AExpr d info -> failCons d (traceFail
    "AFCSubst.substExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substExpr" (showCons x2))

d_OP_substExpr_dot_substBinding_dot_26 ::(Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  Curry_FlatCurry.C_TypeExpr) (Curry_AnnotatedFlatCurry.C_AExpr
  Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr)
  (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)
d_OP_substExpr_dot_substBinding_dot_26 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 (d_C_substSnd x1 x3
    cd cs) (d_C_substExpr x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_substExpr_dot_substBinding_dot_26 x1 l cd cs)
    (d_OP_substExpr_dot_substBinding_dot_26 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_substExpr_dot_substBinding_dot_26 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_substExpr_dot_substBinding_dot_26 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AFCSubst.substExpr.substBinding.26" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substExpr.substBinding.26" (showCons x2))

nd_OP_substExpr_dot_substBinding_dot_26 ::(Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  Curry_FlatCurry.C_TypeExpr) (Curry_AnnotatedFlatCurry.C_AExpr
  Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  Curry_FlatCurry.C_TypeExpr) (Curry_AnnotatedFlatCurry.C_AExpr
  Curry_FlatCurry.C_TypeExpr)
nd_OP_substExpr_dot_substBinding_dot_26 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (nd_C_substSnd x1 x3 s0 cd cs)
    (nd_C_substExpr x1 x4 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_substExpr_dot_substBinding_dot_26 x1 l s cd cs)
    (nd_OP_substExpr_dot_substBinding_dot_26 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_substExpr_dot_substBinding_dot_26 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_substExpr_dot_substBinding_dot_26 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AFCSubst.substExpr.substBinding.26" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substExpr.substBinding.26" (showCons x2))

d_C_substSnd ::(Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 t0
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  t0 Curry_FlatCurry.C_TypeExpr
d_C_substSnd x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3 (d_C_subst x1 x4
    cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_substSnd x1 l cd cs)
    (d_C_substSnd x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_substSnd
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_substSnd x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AFCSubst.substSnd" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substSnd" (showCons x2))

nd_C_substSnd ::(Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 t0
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr
nd_C_substSnd x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x3 (nd_C_subst x1 x4 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_substSnd x1 l s cd
    cs) (nd_C_substSnd x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_substSnd
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_substSnd x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AFCSubst.substSnd" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substSnd" (showCons x2))

d_C_substBranch :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr
d_C_substBranch x1 x2 cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_ABranch x3 x4 -> Curry_AnnotatedFlatCurry.C_ABranch
    (d_C_substPattern x1 x3 cd cs) (d_C_substExpr x1 x4 cd cs)
  Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r -> narrow d i
    (d_C_substBranch x1 l cd cs) (d_C_substBranch x1 r cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs -> narrows cs d i (\z ->
    d_C_substBranch x1 z cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e -> guardCons d c
    (d_C_substBranch x1 e cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info -> failCons d (traceFail
    "AFCSubst.substBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substBranch" (showCons x2))

nd_C_substBranch :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr
nd_C_substBranch x1 x2 s cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_ABranch x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_AnnotatedFlatCurry.C_ABranch (nd_C_substPattern
    x1 x3 s0 cd cs) (nd_C_substExpr x1 x4 s1 cd cs)))
  Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r -> narrow d i
    (nd_C_substBranch x1 l s cd cs) (nd_C_substBranch x1 r s cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs -> narrows cs d i (\z ->
    nd_C_substBranch x1 z s cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e -> guardCons d c
    (nd_C_substBranch x1 e s cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info -> failCons d (traceFail
    "AFCSubst.substBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substBranch" (showCons x2))

d_C_substPattern :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern
  Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
d_C_substPattern x1 x2 cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5 -> Curry_AnnotatedFlatCurry.C_APattern
    (d_C_subst x1 x3 cd cs) (d_C_substSnd x1 x4 cd cs) (Curry_Prelude.d_C_map
    (d_C_substSnd x1) x5 cd cs)
  Curry_AnnotatedFlatCurry.C_ALPattern x6 x7 -> Curry_AnnotatedFlatCurry.C_ALPattern
    (d_C_subst x1 x6 cd cs) x7
  Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r -> narrow d i
    (d_C_substPattern x1 l cd cs) (d_C_substPattern x1 r cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs -> narrows cs d i (\z ->
    d_C_substPattern x1 z cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_APattern d c e -> guardCons d c
    (d_C_substPattern x1 e cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_APattern d info -> failCons d (traceFail
    "AFCSubst.substPattern" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substPattern" (showCons x2))

nd_C_substPattern :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern
  Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
nd_C_substPattern x1 x2 s cd cs = case x2 of
  Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5 -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq`
    Curry_AnnotatedFlatCurry.C_APattern (nd_C_subst x1 x3 s0 cd cs)
    (nd_C_substSnd x1 x4 s1 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_substSnd x1)) x5 s2 cd cs)))))
  Curry_AnnotatedFlatCurry.C_ALPattern x6 x7 -> let s0 = s
    in s0 `seq` Curry_AnnotatedFlatCurry.C_ALPattern (nd_C_subst x1 x6 s0 cd cs)
    x7
  Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r -> narrow d i
    (nd_C_substPattern x1 l s cd cs) (nd_C_substPattern x1 r s cd cs)
  Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs -> narrows cs d i (\z ->
    nd_C_substPattern x1 z s cd cs) xs
  Curry_AnnotatedFlatCurry.Guard_C_APattern d c e -> guardCons d c
    (nd_C_substPattern x1 e s cd $! addCs c cs)
  Curry_AnnotatedFlatCurry.Fail_C_APattern d info -> failCons d (traceFail
    "AFCSubst.substPattern" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.substPattern" (showCons x2))

d_C_subst :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
  -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore
  -> Curry_FlatCurry.C_TypeExpr
d_C_subst x1 x2 cd cs = case x2 of
  Curry_FlatCurry.C_TVar x3 -> Curry_Prelude.d_C_maybe x2 Curry_Prelude.d_C_id
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_lookupAFCSubst cd cs)
    x1 cd cs) x3 cd cs) cd cs
  Curry_FlatCurry.C_TCons x4 x5 -> Curry_FlatCurry.C_TCons x4
    (Curry_Prelude.d_C_map (d_C_subst x1) x5 cd cs)
  Curry_FlatCurry.C_FuncType x6 x7 -> Curry_FlatCurry.C_FuncType (d_C_subst x1
    x6 cd cs) (d_C_subst x1 x7 cd cs)
  Curry_FlatCurry.Choice_C_TypeExpr d i l r -> narrow d i (d_C_subst x1 l cd cs)
    (d_C_subst x1 r cd cs)
  Curry_FlatCurry.Choices_C_TypeExpr d i xs -> narrows cs d i (\z -> d_C_subst
    x1 z cd cs) xs
  Curry_FlatCurry.Guard_C_TypeExpr d c e -> guardCons d c (d_C_subst x1 e cd $!
    addCs c cs)
  Curry_FlatCurry.Fail_C_TypeExpr d info -> failCons d (traceFail
    "AFCSubst.subst" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.subst" (showCons x2))

nd_C_subst :: Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_FlatCurry.C_TypeExpr
nd_C_subst x1 x2 s cd cs = case x2 of
  Curry_FlatCurry.C_TVar x3 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_maybe x2 (wrapDX id
    Curry_Prelude.d_C_id) (let s3 = leftSupply s4
                               s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_lookupAFCSubst s0 cd
    cs) x1 s1 cd cs)) x3 s3 cd cs)) s5 cd cs))
  Curry_FlatCurry.C_TCons x4 x5 -> let s0 = s
    in s0 `seq` Curry_FlatCurry.C_TCons x4 (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_subst x1)) x5 s0 cd cs)
  Curry_FlatCurry.C_FuncType x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_FlatCurry.C_FuncType (nd_C_subst x1 x6 s0 cd cs)
    (nd_C_subst x1 x7 s1 cd cs)))
  Curry_FlatCurry.Choice_C_TypeExpr d i l r -> narrow d i (nd_C_subst x1 l s cd
    cs) (nd_C_subst x1 r s cd cs)
  Curry_FlatCurry.Choices_C_TypeExpr d i xs -> narrows cs d i (\z -> nd_C_subst
    x1 z s cd cs) xs
  Curry_FlatCurry.Guard_C_TypeExpr d c e -> guardCons d c (nd_C_subst x1 e s
    cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_TypeExpr d info -> failCons d (traceFail
    "AFCSubst.subst" [show x1, show x2] info)
  _ -> failCons cd (consFail "AFCSubst.subst" (showCons x2))

