{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module AbstractCurry.Curry_Files
  ( d_C_readCurry
  , d_C_readUntypedCurry
  , d_C_readCurryWithParseOptions
  , d_C_readUntypedCurryWithParseOptions
  , d_C_abstractCurryFileName
  , d_C_untypedAbstractCurryFileName
  , d_C_readAbstractCurryFile
  , d_C_tryReadACYFile
  , d_C_writeAbstractCurryFile )
  where

import Basics
import qualified AbstractCurry.Curry_Types
import qualified Curry_Char
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_FilePath
import qualified Curry_Maybe
import qualified Curry_Prelude
import qualified Curry_ReadShowTerm


d_C_readCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readCurry x1 cd cs = d_C_readCurryWithParseOptions x1
  (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True
  (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs

d_C_readUntypedCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readUntypedCurry x1 cd cs = d_C_readUntypedCurryWithParseOptions x1
  (Curry_Distribution.d_C_setQuiet Curry_Prelude.C_True
  (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs

d_C_readCurryWithParseOptions :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Distribution.C_FrontendParams -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readCurryWithParseOptions x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_return (Curry_Prelude.d_C_maybe
  Curry_Prelude.C_Nothing (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.C_Just) Curry_Prelude.d_C_fst cd cs)) cd cs) cd cs)
  (d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1 x2 x1) cd cs

d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1 :: Curry_Distribution.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless
  (Curry_Maybe.d_C_isNothing x3 cd cs))
  (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_ACY x1 x2
  cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_findFileInLoadPath (d_C_abstractCurryFileName x2 cd
  cs) cd cs)
  d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
  cd cs) cd cs

d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readCurryWithParseOptions_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 cd cs =
  d_C_readAbstractCurryFile x1 cd cs

d_C_readUntypedCurryWithParseOptions :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Distribution.C_FrontendParams -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readUntypedCurryWithParseOptions x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x1 cd cs)
  (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_return (Curry_Prelude.d_C_maybe
  Curry_Prelude.C_Nothing (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.C_Just) Curry_Prelude.d_C_fst cd cs)) cd cs) cd cs)
  (d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3 x2 x1) cd cs

d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3 :: Curry_Distribution.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless
  (Curry_Maybe.d_C_isNothing x3 cd cs))
  (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_UACY x1 x2
  cd cs) cd cs) (Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Distribution.d_C_findFileInLoadPath (d_C_untypedAbstractCurryFileName
  x2 cd cs) cd cs)
  d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4
  cd cs) cd cs

d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  AbstractCurry.Curry_Types.C_CurryProg
d_OP_readUntypedCurryWithParseOptions_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 cd cs =
  d_C_readAbstractCurryFile x1 cd cs

d_C_abstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_abstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Distribution.d_C_inCurrySubdir (Curry_Distribution.d_C_stripCurrySuffix
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.toCurryString "acy") cd cs

d_C_untypedAbstractCurryFileName :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_untypedAbstractCurryFileName x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Distribution.d_C_inCurrySubdir (Curry_Distribution.d_C_stripCurrySuffix
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.toCurryString "uacy") cd cs

d_C_readAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO AbstractCurry.Curry_Types.C_CurryProg
d_C_readAbstractCurryFile x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18 x1 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x1 cd cs)
  (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5
  x1) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5 x1 x2 cd cs =
  let x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x2 cd cs
      x4 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1
        x3 cd cs
      x5 = d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines
        x3 cd cs
  in d_C__case_5 x4 x1 x5 (Curry_Prelude.d_OP_eq_eq x4
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP2_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.18._#lambda5._#selFP2#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.18._#lambda5._#selFP2#line1"
    (showCons x1))

d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines
    l cd cs)
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18_dot_uscore_hash_lambda5_dot_uscore_hash_selFP3_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.18._#lambda5._#selFP3#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile.readExistingACY.18._#lambda5._#selFP3#lines"
    (showCons x1))

d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18
    x1 cd cs
  Curry_Prelude.C_False -> let x3 = Curry_Distribution.d_C_inCurrySubdir x1 cd
                                 cs
    in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x3 cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7
    x1 x3) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1 l cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda6" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda6" (showCons x2))

d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.C_True -> d_OP_readAbstractCurryFile_dot_readExistingACY_dot_18
    x2 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "EXISTENCE ERROR: AbstractCurry file '")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString
    "' does not exist") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7
    x1 x2 l cd cs)
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7
    x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_readAbstractCurryFile_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7
    x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda6._#lambda7" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.readAbstractCurryFile._#lambda6._#lambda7" (showCons
    x3))

d_C_tryReadACYFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C_tryReadACYFile x1 cd cs = let x2 = Curry_Prelude.d_C_return
                                    Curry_Prelude.C_Nothing cd cs
  in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x2 x1) cd cs

d_OP_tryReadACYFile_dot_tryRead_dot_29 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x3 cd cs)
  (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 x1 x2) cd cs

nd_OP_tryReadACYFile_dot_tryRead_dot_29 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x3 cd cs)
  (wrapNX id (nd_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 x1
  x2)) s0 cd cs

d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
        (Curry_Prelude.C_Char '\n'#)) cd cs) x3 cd cs
      x5 = d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
        x4 cd cs
      x6 = d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
        x4 cd cs
  in d_C__case_4 x5 x6 x1 x2 (Curry_Prelude.d_OP_slash_eq x5
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) cd cs

nd_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8 x1 x2 x3 s cd cs =
  let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x4 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_break (wrapNX id
                               (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                               (acceptCs id Curry_Prelude.d_OP_eq_eq))
                               (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x3 s1 cd
                               cs)
                             x5 = d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
                               x4 cd cs
                             x6 = d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
                               x4 cd cs
  in nd_C__case_4 x5 x6 x1 x2 (Curry_Prelude.d_OP_slash_eq x5
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{- ")
  (Curry_Prelude.d_OP_plus_plus (AbstractCurry.Curry_Types.d_C_version cd cs)
  (Curry_Prelude.toCurryString " -}") cd cs) cd cs) cd cs) s3 cd cs)))

d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP5_hash_line1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.29._#lambda8._#selFP5#line1"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.29._#lambda8._#selFP5#line1"
    (showCons x1))

d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
    l cd cs)
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_tryRead_dot_29_dot_uscore_hash_lambda8_dot_uscore_hash_selFP6_hash_lines
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.29._#lambda8._#selFP6#lines"
    [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile.tryRead.29._#lambda8._#selFP6#lines"
    (showCons x1))

d_OP_tryReadACYFile_dot_uscore_hash_lambda10 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x2 cd cs
  Curry_Prelude.C_False -> let x4 = Curry_Distribution.d_C_inCurrySubdir x2 cd
                                 cs
    in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 l cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadACYFile._#lambda10"
    (showCons x3))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x2 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` (let x4 = Curry_Distribution.d_C_inCurrySubdir x2 cd cs
    in Curry_Prelude.nd_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x4 cd cs)
    (wrapNX id
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1
    x2 x4)) s0 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files.tryReadACYFile._#lambda10"
    (showCons x3))

d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_True -> d_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x3 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x3 l cd cs)
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10._#lambda11" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10._#lambda11" (showCons x4))

nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tryReadACYFile_dot_tryRead_dot_29 x1 x2 x3 s0 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1
    x2 x3 l s cd cs)
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1
    x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_tryReadACYFile_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1
    x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10._#lambda11" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Files.tryReadACYFile._#lambda10._#lambda11" (showCons x4))

d_C_writeAbstractCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeAbstractCurryFile x1 x2 cd cs = Curry_Prelude.d_C_writeFile x1
  (Curry_ReadShowTerm.d_C_showTerm x2 cd cs) cd cs

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_4 x5 x6 x1 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x2 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_3 x6 x1
    (Curry_ReadShowTerm.d_C_readsUnqualifiedTerm (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "AbstractCurry.Types") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "Prelude") Curry_Prelude.OP_List)) x6 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x5 x6 x1 x2 l
    cd cs) (d_C__case_4 x5 x6 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x5 x6
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x5 x6 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_4" [show x5, show x6, show x1, show x2, show x7]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_4" (showCons x7))

nd_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_4 x5 x6 x1 x2 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_error)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x2 cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x1 (Curry_ReadShowTerm.d_C_readsUnqualifiedTerm
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "AbstractCurry.Types")
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    Curry_Prelude.OP_List)) x6 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x5 x6 x1 x2 l
    s cd cs) (nd_C__case_4 x5 x6 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x5
    x6 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_4 x5 x6 x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_4" [show x5, show x6, show x1, show x2, show x7]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_4" (showCons x7))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_3 x6 x1 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_2 x8 x1 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x6 x1 l cd cs)
    (d_C__case_3 x6 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x6
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x6 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x6, show x1, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x9))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_3 x6 x1 x9 s cd cs = case x9 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_2 x8 x1 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_3 x6 x1 l s cd
    cs) (nd_C__case_3 x6 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_3 x6
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_3 x6 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_3" [show x6, show x1, show x9] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_3" (showCons x9))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_2 x8 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_1 x1 x10 x9 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x8 x1 l cd
    cs) (d_C__case_2 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x8
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_2 x8 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x7))

nd_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_2 x8 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_1 x1 x10 x9 x8 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_2 x8 x1 l s
    cd cs) (nd_C__case_2 x8 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_2
    x8 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_2 x8 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Files._case_2" [show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_2" (showCons x7))

d_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_1 x1 x10 x9 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> d_C__case_0 x10 x1 x9 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs) x10 cd cs) cd cs
  Curry_Prelude.OP_Cons x11 x12 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x1 x10 x9 l cd
    cs) (d_C__case_1 x1 x10 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x1
    x10 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_1 x1 x10 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x1, show x10, show x9, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x8))

nd_C__case_1 :: Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> AbstractCurry.Curry_Types.C_CurryProg
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_1 x1 x10 x9 x8 s cd cs = case x8 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_0 x10 x1 x9 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id Curry_Char.d_C_isSpace) s0 cd cs) x10 s1 cd cs)) s3 cd cs))
  Curry_Prelude.OP_Cons x11 x12 -> x1
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_1 x1 x10 x9 l s
    cd cs) (nd_C__case_1 x1 x10 x9 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_1 x1
    x10 x9 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_1 x1 x10 x9 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "AbstractCurry.Files._case_1" [show x1, show x10, show x9, show x8] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_1" (showCons x8))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
d_C__case_0 x10 x1 x9 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
    (Curry_Prelude.C_Just x9) cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x10 x1 x9 l cd
    cs) (d_C__case_0 x10 x1 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x10
    x1 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x10 x1 x9 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x10, show x1, show x9, show x11] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x11))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CurryProg)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CurryProg)
nd_C__case_0 x10 x1 x9 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_return)
    (Curry_Prelude.C_Just x9) s0 cd cs
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x10 x1 x9 l s
    cd cs) (nd_C__case_0 x10 x1 x9 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x10
    x1 x9 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x10 x1 x9 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_0" [show x10, show x1, show x9, show x11] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_0" (showCons x11))

d_C__case_5 ::(Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
d_C__case_5 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_return
    (Curry_ReadShowTerm.d_C_readUnqualifiedTerm (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "AbstractCurry.Types") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "Prelude") Curry_Prelude.OP_List)) x5 cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "AbstractCurry: incompatible file found: ") x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x4 x1 x5 l cd
    cs) (d_C__case_5 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x4 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Files._case_5" [show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Files._case_5" (showCons x6))

