{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_ModuleDeps ( C_ModuleIdent, C_Errors, C_Source, d_C_deps ) where

import Basics
import qualified Curry_CompilerOpts
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_FilePath
import qualified Curry_Files
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_Function
import qualified Curry_List
import qualified Curry_Maybe
import qualified Curry_Message
import qualified Curry_Names
import qualified Curry_Prelude
import qualified Curry_RCFile
import qualified Curry_SCC
import qualified Curry_System
import qualified Curry_Time


type C_ModuleIdent = Curry_Prelude.OP_List Curry_Prelude.C_Char

type C_Errors = Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)

type C_Source = Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog

type C_SourceEnv = Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))

d_C_deps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_deps x1 x2 x3 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_sourceDeps x1 x2 x3
  (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs) cd cs)
  (d_OP_deps_dot_uscore_hash_lambda1 x3 x2) cd cs

d_OP_deps_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = let x4 = d_C_filterMissing x3
                                                         cd cs
                                                       x5 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1
                                                         x4 cd cs
                                                       x6 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1
                                                         x4 cd cs
                                                       x7 = Curry_Prelude.d_C_apply
                                                         (d_C_flattenDeps cd cs)
                                                         x5 cd cs
                                                       x8 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2
                                                         x7 cd cs
                                                       x9 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2
                                                         x7 cd cs
  in Curry_Prelude.d_OP_gt_gt_eq (d_C_checkFlatCurry x2 x1 cd cs)
  (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x6 x9 x8) cd cs

nd_OP_deps_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
nd_OP_deps_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` (let x4 = nd_C_filterMissing x3 s0
                                                   cd cs
                                                 x5 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1
                                                   x4 cd cs
                                                 x6 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1
                                                   x4 cd cs
                                                 x7 = Curry_Prelude.nd_C_apply
                                                   (wrapDX id (d_C_flattenDeps
                                                   cd cs)) x5 s1 cd cs
                                                 x8 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2
                                                   x7 cd cs
                                                 x9 = d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2
                                                   x7 cd cs
  in Curry_Prelude.nd_OP_gt_gt_eq (d_C_checkFlatCurry x2 x1 cd cs) (wrapDX id
  (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x6 x9 x8)) s2 cd
  cs)))))

d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP5_hash_mods1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda1._#selFP5#mods1" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda1._#selFP5#mods1"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP6_hash_errs1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda1._#selFP6#errs1" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda1._#selFP6#errs1"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP3_hash_mods2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda1._#selFP3#mods2" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda1._#selFP3#mods2"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_selFP4_hash_errs2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda1._#selFP4#errs2" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda1._#selFP4#errs2"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_return (Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.d_C_concat
  (Curry_Prelude.OP_Cons x1 (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x4
  Curry_Prelude.OP_List))) cd cs)) cd cs

d_C_checkFlatCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_checkFlatCurry x1 x2 cd cs = d_C__case_19 x2 x1 (d_C_isFlatCurryFile x2 cd
  cs) cd cs

d_OP_checkFlatCurry_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_checkFlatCurry_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x3 x1 x2)
  cd cs

d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 x3 x4 cd cs =
  d_C__case_17 x4 x1 x2 x3 (Curry_Prelude.d_OP_amp_amp x1 x4 cd cs) cd cs

d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Time.C_ClockTime -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_getModificationTime x1 cd cs)
  (d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6
  x3 x1 x2) cd cs

d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 :: Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_return (d_C__case_14 x1 x4 x3 x2 (Curry_Prelude.d_OP_lt x4
  x1 cd cs) cd cs) cd cs

d_C_moduleDeps :: Curry_CompilerOpts.C_Options -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
d_C_moduleDeps x1 x2 x3 cd cs = d_C__case_13 x3 x2 x1
  (Curry_FiniteMap.d_C_lookupFM x2 x3 cd cs) cd cs

nd_C_moduleDeps :: Curry_CompilerOpts.C_Options -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
nd_C_moduleDeps x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_13 x3 x2 x1 (Curry_FiniteMap.nd_C_lookupFM x2
  x3 s0 cd cs) s1 cd cs))

d_OP_moduleDeps_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
d_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
    (Curry_FiniteMap.d_C_addToFM x2 x1 Curry_Prelude.C_Nothing cd cs) cd cs
  Curry_Prelude.C_Just x5 -> d_C_sourceDeps (d_C__case_12 x3 cd cs) x1 x5 x2 cd
    cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 l cd cs)
    (d_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps.moduleDeps._#lambda8" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "ModuleDeps.moduleDeps._#lambda8" (showCons x4))

nd_OP_moduleDeps_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
nd_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.C_Nothing -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_return) (Curry_FiniteMap.nd_C_addToFM x2 x1
    Curry_Prelude.C_Nothing s0 cd cs) s1 cd cs))
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq` nd_C_sourceDeps (d_C__case_12 x3 cd cs) x1 x5 x2 s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 l s cd cs)
    (nd_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_moduleDeps_dot_uscore_hash_lambda8 x1 x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps.moduleDeps._#lambda8" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "ModuleDeps.moduleDeps._#lambda8" (showCons x4))

d_C_lookupModule :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_lookupModule x1 x2 cd cs = let x3 = Curry_Prelude.OP_Cons
                                     (Curry_Prelude.toCurryString ".")
                                     (Curry_CompilerOpts.d_C_optImportPaths x1
                                     cd cs)
  in Curry_Files.d_C_lookupFileInPath (Curry_Prelude.d_C_apply
  (Curry_Names.d_C_moduleNameToPath cd cs) x2 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".curry") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".lcurry") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".fcy") Curry_Prelude.OP_List)))
  (Curry_Prelude.d_C_map Curry_FilePath.d_C_dropTrailingPathSeparator x3 cd cs)
  cd cs

d_C_sourceDeps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)))
d_C_sourceDeps x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_gt_gt_eq
  (d_C_readCurrySource x1 x2 x3 cd cs) (d_OP_sourceDeps_dot_uscore_hash_lambda24
  x3 x4 x1) cd cs

nd_C_sourceDeps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
nd_C_sourceDeps x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (d_C_readCurrySource x1 x2 x3 cd cs)
  (wrapNX id (nd_OP_sourceDeps_dot_uscore_hash_lambda24 x3 x4 x1)) s0 cd cs

d_OP_sourceDeps_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_CompilerOpts.C_Options -> Curry_FlatCurry.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
d_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 x4 cd cs = case x4 of
  Curry_FlatCurry.C_Prog x5 x6 x7 x8 x9 -> Curry_Prelude.d_C_foldIO (acceptCs id
    (d_C_moduleDeps x3)) (Curry_FiniteMap.d_C_addToFM x2 x5
    (Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple2 x1 x4)) cd cs) x6 cd cs
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (d_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 l cd cs)
    (d_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 z cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (d_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 e cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "ModuleDeps.sourceDeps._#lambda24" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "ModuleDeps.sourceDeps._#lambda24" (showCons x4))

nd_OP_sourceDeps_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> Curry_CompilerOpts.C_Options -> Curry_FlatCurry.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
nd_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_FlatCurry.C_Prog x5 x6 x7 x8 x9 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldIO (wrapDX (wrapNX id)
    (acceptCs id (nd_C_moduleDeps x3))) (Curry_FiniteMap.nd_C_addToFM x2 x5
    (Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple2 x1 x4)) s0 cd cs) x6 s1 cd
    cs))
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i
    (nd_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 l s cd cs)
    (nd_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 r s cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 z s cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c
    (nd_OP_sourceDeps_dot_uscore_hash_lambda24 x1 x2 x3 e s cd $! addCs c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "ModuleDeps.sourceDeps._#lambda24" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "ModuleDeps.sourceDeps._#lambda24" (showCons x4))

d_C_readCurrySource :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_FlatCurry.C_Prog
d_C_readCurrySource x1 x2 x3 cd cs = let x4 = Curry_Prelude.OP_Cons
                                           (Curry_Prelude.toCurryString ".")
                                           (Curry_CompilerOpts.d_C_optImportPaths
                                           x1 cd cs)
  in d_C__case_11 x3 x1 x4 x2 (d_C_isFlatCurryFile x3 cd cs) cd cs

d_OP_readCurrySource_dot_uscore_hash_lambda25 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_FlatCurry.C_Prog
d_OP_readCurrySource_dot_uscore_hash_lambda25 x1 x2 cd cs =
  d_C_preprocessFcyFile x1 x2 cd cs

d_C_preprocessFcyFile :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_FlatCurry.C_Prog
d_C_preprocessFcyFile x1 x2 cd cs = let x3 = d_C__case_9 x1 cd cs
                                        x17 = Curry_RCFile.d_C_rcValue
                                          (Curry_CompilerOpts.d_C_rcVars x3 cd
                                          cs) (Curry_Prelude.toCurryString
                                          "bindingoptimization") cd cs
                                        x18 = Curry_Prelude.d_C_apply
                                          (Curry_Prelude.d_C_apply
                                          (Curry_FilePath.d_OP_lt_slash_gt cd
                                          cs) (Curry_Distribution.d_C_installDir
                                          cd cs) cd cs) (Curry_Prelude.d_C_apply
                                          (Curry_Prelude.d_C_apply
                                          (Curry_FilePath.d_OP_lt_slash_gt cd
                                          cs) (Curry_Prelude.toCurryString
                                          "currytools") cd cs)
                                          (Curry_Prelude.d_C_apply
                                          (Curry_Prelude.d_C_apply
                                          (Curry_FilePath.d_OP_lt_slash_gt cd
                                          cs) (Curry_Prelude.toCurryString
                                          "optimize") cd cs)
                                          (Curry_Prelude.toCurryString
                                          "bindingopt") cd cs) cd cs) cd cs
  in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x18 cd cs)
  (d_OP_preprocessFcyFile_dot_uscore_hash_lambda40 x2 x18 x3 x17) cd cs

d_OP_preprocessFcyFile_dot_uscore_hash_lambda40 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_FlatCurry.C_Prog
d_OP_preprocessFcyFile_dot_uscore_hash_lambda40 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_when
  (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_slash_eq x4
  (Curry_Prelude.toCurryString "no") cd cs) x5 cd cs)) (Curry_Prelude.d_OP_gt_gt
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showAnalysis x3)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Pre-processing file ") x1 cd cs) cd cs)
  (let x6 = let x7 = Curry_Prelude.toCurryString "-v0"
         in d_C__case_8 x3 x7 (Curry_CompilerOpts.d_C_optVerbosity x3 cd cs) cd
         cs
       x8 = d_C__case_7 x4 (Curry_Prelude.d_OP_eq_eq x4
         (Curry_Prelude.toCurryString "full") cd cs) cd cs
       x9 = Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x2
         (Curry_Prelude.OP_Cons x6 (Curry_Prelude.OP_Cons x8
         (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List)))) cd cs
  in Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
  (Curry_Message.d_C_showAnalysis x3) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Executing: ") x9 cd cs) cd cs)
  (Curry_Prelude.d_OP_gt_gt_eq (Curry_System.d_C_system x9 cd cs)
  (d_OP_preprocessFcyFile_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1)
  cd cs) cd cs) cd cs) cd cs) (Curry_FlatCurry.d_C_readFlatCurryFile x1 cd cs)
  cd cs

d_OP_preprocessFcyFile_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_preprocessFcyFile_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1 x2 cd cs =
  Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless (Curry_Prelude.d_OP_eq_eq
  x2 (Curry_Prelude.C_Int 0#) cd cs)) (Curry_Prelude.d_OP_gt_gt
  (Curry_Prelude.d_C_putStrLn (Curry_Prelude.toCurryString
  "WARNING: Binding optimization failed for file:") cd cs)
  (Curry_Prelude.d_C_putStrLn x1 cd cs) cd cs) cd cs

d_C_parseCurryWithOptions :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Distribution.C_FrontendParams -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_parseCurryWithOptions x1 x2 x3 cd cs = let x4 = Curry_Prelude.OP_Cons
                                                 (Curry_Prelude.toCurryString
                                                 ".")
                                                 (Curry_CompilerOpts.d_C_optImportPaths
                                                 x1 cd cs)
  in Curry_Prelude.d_OP_gt_gt_eq (d_C_lookupModule x1 x2 cd cs)
  (d_OP_parseCurryWithOptions_dot_uscore_hash_lambda43 x4 x2 x3) cd cs

d_OP_parseCurryWithOptions_dot_uscore_hash_lambda43 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Distribution.C_FrontendParams
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_parseCurryWithOptions_dot_uscore_hash_lambda43 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless
  (Curry_Maybe.d_C_isNothing x4 cd cs))
  (Curry_Distribution.d_C_callFrontendWithParams Curry_Distribution.C_FCY x3 x2
  cd cs) cd cs) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_liftIO
  Curry_FilePath.d_C_normalise) (Curry_Files.d_C_getFileInPath
  (Curry_FlatCurry.d_C_flatCurryFileName x2 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List Curry_Prelude.OP_List) (Curry_Prelude.d_C_map
  Curry_FilePath.d_C_dropTrailingPathSeparator x1 cd cs) cd cs) cd cs) cd cs

d_C_isFlatCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isFlatCurryFile x1 cd cs = Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_apply
  (Curry_FilePath.d_C_takeExtension cd cs) x1 cd cs)
  (Curry_Prelude.toCurryString ".fcy") cd cs

d_C_filterMissing :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_filterMissing x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                                   (Curry_List.d_C_partition
                                   (Curry_Prelude.d_OP_dot
                                   Curry_Maybe.d_C_isJust Curry_Prelude.d_C_snd
                                   cd cs)) (Curry_FiniteMap.d_C_fmToList x1 cd
                                   cs) cd cs
                                 x3 = d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present
                                   x2 cd cs
                                 x4 = d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing
                                   x2 cd cs
                                 x5 = Curry_Prelude.d_C_map
                                   d_OP_filterMissing_dot_uscore_hash_lambda44
                                   x4 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map (Curry_Function.d_C_second
  Curry_Maybe.d_C_fromJust) x3 cd cs) x5

nd_C_filterMissing :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_filterMissing x1 s cd cs = let s7 = s
  in s7 `seq` (let s3 = leftSupply s7
                   s8 = rightSupply s7
                   s5 = leftSupply s8
                   s6 = rightSupply s8
  in s3 `seq` (s8 `seq` (s5 `seq` (s6 `seq` (let x2 = let s2 = leftSupply s3
                                                          s4 = rightSupply s3
                                                          s0 = leftSupply s4
                                                          s1 = rightSupply s4
                                                   in s2 `seq` (s4 `seq`
                                                   (s0 `seq` (s1 `seq`
                                                   Curry_Prelude.nd_OP_dollar
                                                   (wrapNX id
                                                   (Curry_List.nd_C_partition
                                                   (Curry_Prelude.nd_OP_dot
                                                   (wrapDX id
                                                   Curry_Maybe.d_C_isJust)
                                                   (wrapDX id
                                                   Curry_Prelude.d_C_snd) s0 cd
                                                   cs)))
                                                   (Curry_FiniteMap.nd_C_fmToList
                                                   x1 s1 cd cs) s2 cd cs)))
                                                 x3 = d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present
                                                   x2 cd cs
                                                 x4 = d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing
                                                   x2 cd cs
                                                 x5 = Curry_Prelude.nd_C_map
                                                   (wrapDX id
                                                   d_OP_filterMissing_dot_uscore_hash_lambda44)
                                                   x4 s5 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_map (wrapNX id
  (Curry_Function.nd_C_second (wrapDX id Curry_Maybe.d_C_fromJust))) x3 s6 cd
  cs) x5)))))

d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_selFP8_hash_present e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#selFP8#present" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#selFP8#present"
    (showCons x1))

d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_selFP9_hash_missing e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#selFP9#missing" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#selFP9#missing"
    (showCons x1))

d_OP_filterMissing_dot_uscore_hash_lambda44 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_filterMissing_dot_uscore_hash_lambda44 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Module ") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString " could not be found") cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_lambda44 l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_lambda44 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_lambda44 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_lambda44 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#lambda44" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#lambda44" (showCons
    x1))

d_C_flattenDeps :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_flattenDeps cd cs = let x1 = Curry_SCC.d_C_scc
                              d_OP_flattenDeps_dot_modules_dot_75
                              d_OP_flattenDeps_dot_imports_dot_75 cd cs
                            x2 = Curry_Prelude.d_C_foldr (acceptCs id
                              d_OP_flattenDeps_dot_checkdep_dot_74)
                              (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
                              Curry_Prelude.OP_List)
  in Curry_Prelude.d_OP_dot x2 x1 cd cs

d_OP_flattenDeps_dot_modules_dot_75 ::(Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_flattenDeps_dot_modules_dot_75 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Cons x2
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_modules_dot_75 l cd cs)
    (d_OP_flattenDeps_dot_modules_dot_75 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_modules_dot_75 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_modules_dot_75 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.modules.75" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.modules.75" (showCons x1))

d_OP_flattenDeps_dot_imports_dot_75 ::(Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 t1 Curry_FlatCurry.C_Prog) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_flattenDeps_dot_imports_dot_75 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_6 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_imports_dot_75 l cd cs)
    (d_OP_flattenDeps_dot_imports_dot_75 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_imports_dot_75 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_imports_dot_75 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.imports.75" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.imports.75" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_74 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_flattenDeps_dot_cyclicError_dot_74 x1 cd cs =
  let x2 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 x1 cd cs
      x3 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits
        x2 cd cs
      x4 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last
        x2 cd cs
  in Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Cylic import dependency between modules ") (Curry_Prelude.d_OP_plus_plus
  (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ", ") x3 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " and ") x4 cd cs)
  cd cs) cd cs

d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0
d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "ModuleDeps.splitLast: empty list") cd cs
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_4 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98 e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98._#selFP12#xs" [show x1]
    info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98._#selFP12#xs" (showCons
    x1))

d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0 -> Cover
  -> ConstStore -> t0
d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98._#selFP13#z" [show x1]
    info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.74.splitLast.98._#selFP13#z" (showCons
    x1))

d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP14_hash_inits
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.74._#selFP14#inits" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.74._#selFP14#inits" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last l
    cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_74_dot_uscore_hash_selFP15_hash_last e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.74._#selFP15#last" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.74._#selFP15#last" (showCons x1))

d_OP_flattenDeps_dot_checkdep_dot_74 ::(Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_flattenDeps_dot_checkdep_dot_74 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C__case_3 x2 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_2 x2 x1 x5 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_flattenDeps_dot_checkdep_dot_74 l x2 cd cs)
    (d_OP_flattenDeps_dot_checkdep_dot_74 r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_checkdep_dot_74 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_flattenDeps_dot_checkdep_dot_74 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.checkdep.74" [show x1, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.checkdep.74" (showCons x1))

d_C__case_2 ::(Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_2 x2 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_1 x5 x2 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> d_C__case_0 x1 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x2 x1 x5 l cd
    cs) (d_C__case_2 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x2
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_2 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps._case_2" [show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "ModuleDeps._case_2" (showCons x6))

d_C__case_0 ::(Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> Curry_Prelude.OP_Tuple2 x11
    (Curry_Prelude.OP_Cons (d_OP_flattenDeps_dot_cyclicError_dot_74
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst x1 cd cs) cd cs) x12)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_0 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_0" [show x1, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_0" (showCons x2))

d_C__case_1 ::(Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_1 x5 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Cons x5 x7) x8
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x5 l cd cs)
    (d_C__case_1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x5
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_1 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_1" [show x5, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_1" (showCons x2))

d_C__case_3 ::(Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3 x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_3" [show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_3" (showCons x2))

d_C__case_4 ::(Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  t0
d_C__case_4 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x2
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98
                                       (Curry_Prelude.OP_Cons x4 x5) cd cs
                                     x7 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP12_hash_xs
                                       x6 cd cs
                                     x8 = d_OP_flattenDeps_dot_cyclicError_dot_74_dot_splitLast_dot_98_dot_uscore_hash_selFP13_hash_z
                                       x6 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x2 x7) x8
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x2 l cd cs)
    (d_C__case_4 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_4 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps._case_4" [show x2, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_4" (showCons x3))

d_C__case_6 ::(Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t1
  Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_6 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_5 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_6 l cd cs)
    (d_C__case_6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_6 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_6 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_6" [show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_6" (showCons x3))

d_C__case_5 :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_5 x5 cd cs = case x5 of
  Curry_FlatCurry.C_Prog x6 x7 x8 x9 x10 -> x7
  Curry_FlatCurry.Choice_C_Prog d i l r -> narrow d i (d_C__case_5 l cd cs)
    (d_C__case_5 r cd cs)
  Curry_FlatCurry.Choices_C_Prog d i xs -> narrows cs d i (\z -> d_C__case_5 z
    cd cs) xs
  Curry_FlatCurry.Guard_C_Prog d c e -> guardCons d c (d_C__case_5 e cd $! addCs
    c cs)
  Curry_FlatCurry.Fail_C_Prog d info -> failCons d (traceFail
    "ModuleDeps._case_5" [show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_5" (showCons x5))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_7 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString "-f"
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x4 l cd cs)
    (d_C__case_7 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_7 x4 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "ModuleDeps._case_7"
    [show x4, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_7" (showCons x5))

d_C__case_8 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_CompilerOpts.C_Verbosity -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_8 x3 x7 x8 cd cs = case x8 of
  Curry_CompilerOpts.C_VerbAnalysis -> Curry_Prelude.toCurryString "-v1"
  Curry_CompilerOpts.C_VerbDetails -> Curry_Prelude.toCurryString "-v3"
  Curry_CompilerOpts.C_VerbQuiet -> x7
  Curry_CompilerOpts.C_VerbFrontend -> x7
  Curry_CompilerOpts.C_VerbStatus -> x7
  Curry_CompilerOpts.Choice_C_Verbosity d i l r -> narrow d i (d_C__case_8 x3 x7
    l cd cs) (d_C__case_8 x3 x7 r cd cs)
  Curry_CompilerOpts.Choices_C_Verbosity d i xs -> narrows cs d i (\z ->
    d_C__case_8 x3 x7 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Verbosity d c e -> guardCons d c (d_C__case_8 x3 x7
    e cd $! addCs c cs)
  Curry_CompilerOpts.Fail_C_Verbosity d info -> failCons d (traceFail
    "ModuleDeps._case_8" [show x3, show x7, show x8] info)
  _ -> failCons cd (consFail "ModuleDeps._case_8" (showCons x8))

d_C__case_9 :: Curry_CompilerOpts.C_Options -> Cover -> ConstStore
  -> Curry_CompilerOpts.C_Options
d_C__case_9 x1 cd cs = case x1 of
  Curry_CompilerOpts.C_Opts x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 -> Curry_CompilerOpts.C_Opts
    x4 x5 (Curry_CompilerOpts.d_C_optMainVerbosity x1 cd cs) x7 x8 x9 x10 x11
    x12 x13 x14 x15 x16
  Curry_CompilerOpts.Choice_C_Options d i l r -> narrow d i (d_C__case_9 l cd
    cs) (d_C__case_9 r cd cs)
  Curry_CompilerOpts.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_9 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Options d c e -> guardCons d c (d_C__case_9 e cd $!
    addCs c cs)
  Curry_CompilerOpts.Fail_C_Options d info -> failCons d (traceFail
    "ModuleDeps._case_9" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps._case_9" (showCons x1))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_FlatCurry.C_Prog
d_C__case_11 x3 x1 x4 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
    (Curry_Message.d_C_showStatus x1) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Reading directly from FlatCurry file '")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "'") cd cs) cd
    cs) cd cs) (d_C_preprocessFcyFile x1 x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_10 x1 x4 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x3 x1 x4 x2 l
    cd cs) (d_C__case_11 x3 x1 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x3
    x1 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_11 x3 x1 x4 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_11" [show x3, show x1, show x4, show x2, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_11" (showCons x5))

d_C__case_10 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_FlatCurry.C_Prog
d_C__case_10 x1 x4 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_OP_dollar
    (d_C_parseCurryWithOptions x1 (Curry_Distribution.d_C_stripCurrySuffix x2 cd
    cs)) (Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setFullPath x4)
    (Curry_Prelude.d_OP_dollar (Curry_Distribution.d_C_setQuiet
    (Curry_Prelude.d_OP_eq_eq (Curry_CompilerOpts.d_C_optVerbosity x1 cd cs)
    Curry_CompilerOpts.C_VerbQuiet cd cs)) (Curry_Distribution.d_C_setSpecials
    (Curry_CompilerOpts.d_C_optParser x1 cd cs)
    (Curry_Distribution.d_C_defaultParams cd cs) cd cs) cd cs) cd cs) cd cs)
    (d_OP_readCurrySource_dot_uscore_hash_lambda25 x1) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 x4 x2 l cd
    cs) (d_C__case_10 x1 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_10 x1 x4 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_10" [show x1, show x4, show x2, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_10" (showCons x5))

d_C__case_12 :: Curry_CompilerOpts.C_Options -> Cover -> ConstStore
  -> Curry_CompilerOpts.C_Options
d_C__case_12 x3 cd cs = case x3 of
  Curry_CompilerOpts.C_Opts x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 -> Curry_CompilerOpts.C_Opts
    x6 x7 Curry_CompilerOpts.C_VerbQuiet x9 x10 x11 x12 x13 x14 x15 x16 x17 x18
  Curry_CompilerOpts.Choice_C_Options d i l r -> narrow d i (d_C__case_12 l cd
    cs) (d_C__case_12 r cd cs)
  Curry_CompilerOpts.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_12 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Options d c e -> guardCons d c (d_C__case_12 e
    cd $! addCs c cs)
  Curry_CompilerOpts.Fail_C_Options d info -> failCons d (traceFail
    "ModuleDeps._case_12" [show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_12" (showCons x3))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Maybe (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
d_C__case_13 x3 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_C_return x2 cd cs
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_gt_gt_eq (d_C_lookupModule x1 x3
    cd cs) (d_OP_moduleDeps_dot_uscore_hash_lambda8 x3 x2 x1) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_13 x3 x2 x1 l cd
    cs) (d_C__case_13 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_13 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_13 x3 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps._case_13" [show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_13" (showCons x5))

nd_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog)) -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Maybe (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_FlatCurry.C_Prog)))
nd_C__case_13 x3 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_C_return x2 cd cs
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (d_C_lookupModule x1 x3 cd cs)
    (wrapNX id (nd_OP_moduleDeps_dot_uscore_hash_lambda8 x3 x2 x1)) s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_13 x3 x2 x1 l s
    cd cs) (nd_C__case_13 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_13 x3
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_13 x3 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps._case_13" [show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_13" (showCons x5))

d_C__case_14 :: Curry_Time.C_ClockTime -> Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_14 x1 x4 x3 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "FlatCurry file ")
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " is older than Curry file ") x3 cd cs) cd cs)
    cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x4 x3 x2 l
    cd cs) (d_C__case_14 x1 x4 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x4 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_14 x1 x4 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_14" [show x1, show x4, show x3, show x2, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_14" (showCons x5))

d_C__case_17 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_17 x4 x1 x2 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt_eq
    (Curry_Directory.d_C_getModificationTime x3 cd cs)
    (d_OP_checkFlatCurry_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
    x2 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_return
    (Curry_Prelude.d_OP_plus_plus (d_C__case_16 x1 x3 (Curry_Prelude.d_C_not x1
    cd cs) cd cs) (d_C__case_15 x4 x2 (Curry_Prelude.d_C_not x4 cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x4 x1 x2 x3 l
    cd cs) (d_C__case_17 x4 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x4
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x4 x1 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_17" [show x4, show x1, show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_17" (showCons x5))

d_C__case_15 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_15 x4 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Missing FlatCurry file ") x2 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x4 x2 l cd cs)
    (d_C__case_15 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x4
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_15 x4 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_15" [show x4, show x2, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_15" (showCons x5))

d_C__case_16 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_16 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Missing Curry file ") x3 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 x3 l cd cs)
    (d_C__case_16 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_16 x1 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_16" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "ModuleDeps._case_16" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_19 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_return Curry_Prelude.OP_List cd cs
  Curry_Prelude.C_False -> d_C__case_18 x2 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x2 x1 l cd cs)
    (d_C__case_19 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_19" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_19" (showCons x3))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_18 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> let x3 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_apply
                                (Curry_FilePath.d_OP_lt_dot_gt cd cs)
                                (Curry_Distribution.d_C_stripCurrySuffix
                                (Curry_Distribution.d_C_inCurrySubdirModule x1
                                x2 cd cs) cd cs) cd cs)
                                (Curry_Prelude.toCurryString "fcy") cd cs
    in Curry_Prelude.d_OP_gt_gt_eq (Curry_Directory.d_C_doesFileExist x2 cd cs)
    (d_OP_checkFlatCurry_dot_uscore_hash_lambda3 x3 x2) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x2 x1 l cd cs)
    (d_C__case_18 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_18 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_18" [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "ModuleDeps._case_18" (showCons x4))

